//framework with glut
//2010/10/3 yamaya takeshi

#include "framework.h"

#include <iostream>
#include <cassert>


#include <GLUT/glut.h>
//mac os
//#include </System/Library/Frameworks/OpenGL.framework/Headers/gl.h>
//#include </System/Library/Frameworks/OpenGL.framework/Headers/glu.h>
//#include </System/Library/Frameworks/GLUT.framework/Headers/glut.h>
using namespace std;

#include <sys/time.h>
typedef unsigned int DWORD;
DWORD timeGetTime()
{
    timeval time;
    gettimeofday(&time, NULL);
    return time.tv_sec*1000 + time.tv_usec/1000;
}


double gettimeofday_sec()
{
    struct timeval tv;
    gettimeofday(&tv, NULL);
    return tv.tv_sec  + ( double )tv.tv_usec*1e-6;
}




class CFrameWork;
static CFrameWork *s_pFrameWork = NULL;





class Vector3
{
public:
  Vector3()
    : x(0),y(0),z(0){}
  double x,y,z;
};
class CTeapot
{
public:
  Vector3 p;
  Vector3 s;
  Vector3 r;

  CTeapot(){}
  virtual void Material()
  {
    {
      float specular[] = { 0.5f, 0.5f, 0.8f, 1.0f };
      float diffuse[] = { 0.5f, 0.5f, 0.8f, 1.0f };
      float ambient[] = { 0.2f, 0.2f, 0.4f, 1.0f };
      float shininess = 10.0f;
      glMaterialfv(GL_FRONT, GL_SPECULAR, specular );
      glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuse );
      glMaterialfv(GL_FRONT, GL_AMBIENT, ambient );
      glMaterialf(GL_FRONT,GL_SHININESS, shininess);
    }

    glEnable( GL_DEPTH_TEST );
  }
  virtual void Draw()
  {
    Material();
    glPushMatrix();{
      glRotated( r.y, 0, 1, 0 );
      glRotated( r.x, 1, 0, 0 );
      glRotated( r.z, 0, 0, 1 );
      glTranslated( p.x, p.y, p.z );
      {
	glutSolidTeapot( 1 );
      }
    }glPopMatrix();
  }
};

class CClear
{
public:
  void Draw()
  {
    {
      glClearColor( 0,0,0,1 );
      //glClearDepth( 1 );
      glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    }
  }
};


class CCamera
{
public:
  int m_ScreenW;
  int m_ScreenH;
  CCamera()
      : m_ScreenW( 1024 )
    , m_ScreenH( 600 )
  {
  }
  void Draw()
  {
    //projection matrix
    {
      glViewport(0, 0, m_ScreenW, m_ScreenH );
      glMatrixMode(GL_PROJECTION);
      glLoadIdentity();
      gluPerspective(40.0f,(GLdouble)m_ScreenW/(GLdouble)m_ScreenH, 3.0f, 7.0f);
    } 

    //view matrix
    if( 1){
      glMatrixMode( GL_MODELVIEW );
      glLoadIdentity();
      gluLookAt ( 0,//GLdouble eyeX,
          0,//GLdouble eyeY,
          5,//GLdouble eyeZ,
          0,//GLdouble centerX,
          0,//GLdouble centerY,
          0,//GLdouble centerZ,
          0,//GLdouble upX,
          1,//GLdouble upY,
          0//GLdouble upZ
          );   
    }


  }  
};

class CLight
{
public:
  void Draw()
  {
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
  }
};

class CFrameWork
{

public:
  CCamera m_Camera;
  CLight m_Light;
  CTeapot m_Teapot;
  CClear m_Clear;

  CFrameWork()
  {
    s_pFrameWork = this;
  }

  void Update()
  {
    {
      const double degreeUnit = 3.14 / 180.0;
      m_Teapot.r.y += degreeUnit * 10;
    }

  }
  void Display()
  {
    Update();
    m_Clear.Draw();
    m_Camera.Draw();
    m_Light.Draw();
    m_Teapot.Draw();

    glFlush();
  }

  void Idle()
  {
    Display();
  }

  void Resize(int w, int h)
  {
    cout << w << "," << h <<endl;
    m_Camera.m_ScreenW = w;
    m_Camera.m_ScreenH = h;
  }
};

static void Display()
{
  s_pFrameWork->Display();
}

static void Idle()
{
  s_pFrameWork->Idle();
}

static void Resize( int w, int h )
{
  s_pFrameWork->Resize( w, h );
}

int IFrameWork::Start( int argc, char**argv )
{
  std::cout << "hello" << std::endl;
  {
    {
      glutInit(&argc, argv);
      glutInitDisplayMode( GLUT_RGBA | GLUT_DEPTH);
      glutInitWindowPosition(100, 100);
      glutInitWindowSize( 1024, 600);
      glutCreateWindow("Hello, world!");
    }

    {
      glutReshapeFunc( Resize );
      glutDisplayFunc( Display );
      glutIdleFunc( Idle );
    }
    CFrameWork framework;
    glutMainLoop();
  }
  return 0;
}

